/*
   This program tests your versions of Heap.java, HeapSort.java,
   and the various Comparers used below.

   You need to define the following Comparer classes:
      ComparerInteger
      ComparerIntegerReverse
      ComparerDouble
      ComparerString
      ComparerStringByLength
      ComparerSampleClassByX
      ComparerSampleClassByLenghtOfS
   When you define ComparerSampleClassByLenghtOfS,
   make use of ComparerStringByLength.

   You should compile this program without errors and without making
   any changes in it!
*/
import java.io.ObjectInputStream;
import java.io.FileInputStream;

public class TestHeapSort
{
   public static void main( String[] args )
   {
      Integer[] arrayOfInts = { new Integer(3), new Integer(7), new Integer(2),
                                new Integer(9), new Integer(8), new Integer(9),
                                new Integer(10), new Integer(4), new Integer(1),
                                new Integer(12) };

      System.out.println("\nThe original array of Integer objects.");
      for (int i = 0; i < arrayOfInts.length; i++)
         System.out.print( arrayOfInts[i] + " " );
      System.out.println();

      Comparer comparator = new ComparerInteger();
      HeapSort sorter = new HeapSort();
      sorter.sort(arrayOfInts, comparator);

      System.out.println("\nThe sorted array of Integer objects.");
      for (int i = 0; i < arrayOfInts.length; i++)
         System.out.print( arrayOfInts[i] + " " );
      System.out.println();


      System.out.println("\nThe reverse sorted array of Integer objects.");
      comparator = new ComparerIntegerReverse();
      sorter.sort(arrayOfInts, comparator);

      for (int i = 0; i < arrayOfInts.length; i++)
         System.out.print( arrayOfInts[i] + " " );
      System.out.println("\n");



      Double[] arrayOfDoubles = { new Double(3.0), new Double(7.1), new Double(2.5),
                                  new Double(9.7), new Double(8.2), new Double(9.7),
                                  new Double(10.3), new Double(4.9), new Double(1.2),
                                  new Double(12.3) };

      System.out.println("\nThe original array of Double objects.");
      for (int i = 0; i < arrayOfDoubles.length; i++)
         System.out.print( arrayOfDoubles[i] + " " );
      System.out.println();

      comparator = new ComparerDouble();
      sorter.sort(arrayOfDoubles, comparator);

      System.out.println("\nThe sorted array of Double objects.");
      for (int i = 0; i < arrayOfDoubles.length; i++)
         System.out.print( arrayOfDoubles[i] + " " );
      System.out.println("\n");



      String[] arrayOfStrings = { new String("hello"),  new String("goodbye"),
                                  new String("help"),   new String("easy"),
                                  new String("useful"), new String("lost"),
                                  new String("found"),  new String("the"),
                                  new String("interesting"), new String("zyxwvuts") };

      System.out.println("\nThe original array of String objects.");
      for (int i = 0; i < arrayOfStrings.length; i++)
         System.out.print( arrayOfStrings[i] + " " );
      System.out.println();

      comparator = new ComparerString();
      sorter.sort(arrayOfStrings, comparator);

      System.out.println("\nThe sorted array of String objects.");
      for (int i = 0; i < arrayOfStrings.length; i++)
         System.out.print( arrayOfStrings[i] + " " );
      System.out.println();


      comparator = new ComparerStringByLength();
      sorter.sort(arrayOfStrings, comparator);

      System.out.println("\nThe sorted array of String objects sorted by length.");
      for (int i = 0; i < arrayOfStrings.length; i++)
         System.out.print( arrayOfStrings[i] + " " );
      System.out.println("\n");



      // Read the serialized object into the Java virtual machine.
      // The serialized object is an array of SampleClass objects.
      SampleClass[] arrayOfSamples2 = null;
      try
      {
         ObjectInputStream inputStream =
                  new ObjectInputStream( new FileInputStream("sampleArray.serialized"));

         arrayOfSamples2 = (SampleClass[])inputStream.readObject();
      }
      catch(Exception e)
      {
         System.out.println("Problem with reading serializing object\n" + e);
      }

      System.out.println("\nThe original array of SampleClass objects.");
      for (int i = 0; i < arrayOfSamples2.length; i++)
         System.out.println( arrayOfSamples2[i] );
      System.out.println("\n");


      comparator = new ComparerSampleClassByX();
      sorter.sort(arrayOfSamples2, comparator);

      System.out.println("The array of SampleClass objects sorted by x.");
      for (int i = 0; i < arrayOfSamples2.length; i++)
         System.out.println( arrayOfSamples2[i] );
      System.out.println("\n");


      comparator = new ComparerSampleClassByLenghtOfS();
      sorter.sort(arrayOfSamples2, comparator);

      System.out.println("The array of SampleClass objects sorted by length of s.");
      for (int i = 0; i < arrayOfSamples2.length; i++)
         System.out.println( arrayOfSamples2[i] );
      System.out.println("\n");

   }//main

}//TestHeapSort